//pinout def
#define DATA P2
#define ADDR P0
#define RW   P44
#define CS   P43
#define RST  P45
#define DEV  P4
#define PPUINT P32  //int0
#define VRAMPG P46 //vram a14

#define SOFTRST P33 //int2 btn1
#define btn2 P34
#define btn3 P35
#define btn4 P54 //need to turn on "reset pin as io port"

#define CTRDAT P04 //NES controller
#define CTRLAT P07
#define CTRCLK P47

//typedef
typedef unsigned char u8;
typedef unsigned int u16;
typedef unsigned long u32;

typedef bit BOOL;
typedef unsigned char BYTE;
typedef unsigned int WORD;
typedef unsigned long DWORD;

typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned int ushort;
typedef unsigned long ulong;

typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long uint32_t;

//valuedef
#define stcclock 52000000UL
#define dots 341
#define lines 312
#define fps 50
#define linemult 2
#define line0 26
#define line240 26+240
#define visstart line0*linemult
#define visend line240*linemult
#define totalline lines*linemult
#define lctinit 65536-(stcclock/linemult/fps/lines)
#define waitym12 8 //min 6

#define waitppu() NOP5()//min nop5

int vblank(u32 frame);
int hblank(u32 frame, u16 line, u16 tick);
